const _ = global.lodash || require('../../../static_dependencies/lodash/lodash.js')

/**
  * IDTOArray class
  *
  * @author jsb4ch <jsb4ch@jsmex.io>
  * @since 1.0.9
  */
class IDTOArray extends Array {
  constructor (...args) {
    super(...args)
    if (this.validate === undefined) {
      throw new Error('Must override .map() method')
    }
    this._map = this.map
    this.map = (...args) => {
      return [...this].map(...args)
    }
  }

  /**
    * IDTOArray toArray method
    *
    * @author jsb4ch <jsb4ch@jsmex.io>
    * @since 1.0.42
    * @returns {Array}
    */
  toArray () {
    return new Array(...this)
  }

  /**
  * IDTOArray isValid method
  *
  * @author jsb4ch <jsb4ch@jsmex.io>
  * @since 1.0.65
  * @returns {Boolean}
  */
  static isValid (listDTOArray) {
    if (!(listDTOArray instanceof Array)) {
      throw new Error('listDTOArray is not instance of array')
    }
    let CurrentDTOArray = this
    let currentDTOArray = new CurrentDTOArray(...listDTOArray)
    return currentDTOArray.validate()
  }
  /**
    * IDTOArray static removeDuplicates
    *
    * @author jsb4ch <jsb4ch@jsmex.io>
    * @since 1.0.42
    * @returns {Array}
    */
  static removeDuplicates (array, field) {
    let Class = this
    let newArray = _.uniqBy(array, field)
    return new Class(...newArray)
  }
}

module.exports = IDTOArray
