/**
* ITrader class
* ITrader is a data explorer interface to be extended by the strategy application
*
* @author jsb4ch <jsb4ch@jsmex.io>
* @since 1.0.0
*/
class ITrader {
  constructor (options) {
    this.options = options
    if (typeof this.validate === 'undefined') {
      const error = { code: 2016, isCritical: true, message: 'validate must be overridden by all subclasses' }
      throw error
    }
  }
}

module.exports = ITrader
